; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
yrot	equ	xrot+4
zrot	equ	xrot+8
SIZEOF_LINE     equ 45
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	fx:dword
local	fy:dword
local	fx2:dword
local	fy2:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,texture
	invoke	GlobalFree
	invoke	GlobalFree,points
	invoke	RtlExitUserProcess,NULL
wmTIMER:movaps	xmm0,xrot
	addps	xmm0,xspeed;0.3, 0.2, 0.4
	movaps	xrot,xmm0
        inc	wiggle_count	
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]
	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
;--------------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,1
;    
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR


        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	movss	xmm3,LightAmbient;=0.5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    
        
	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LEQUAL ;  
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
        invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,SIZEOF_LINE*SIZEOF_LINE*3*4
	mov	points,rax
	xor	edi,edi;x=0
@@:	mov	rsi,points
@3:	cvtsi2ss xmm0,edi
        divss	xmm0,const5
        subss	xmm0,const4_5
        movss	dword ptr [rsi+rdi*4],xmm0   ;points[x][y][0]=x/5.0-4.5
	mov	eax,esi
	sub	rax,points
        cvtsi2ss xmm0,eax
        divss	xmm0,const900
	subss	xmm0,const4_5
	movss 	dword ptr [rsi+rdi*4+SIZEOF_LINE*SIZEOF_LINE*4],xmm0;points[x][y][1]=y/5.0-4.5
	cvtsi2ss xmm0,edi	
	mulss	xmm0,constPi;x*Pi
        divss	xmm0,const22_5
        invoke	sinf;xmm0=sin(x/5*40/360 * Pi * 2)
	movss	dword ptr [rsi+rdi*4+SIZEOF_LINE*SIZEOF_LINE*8],xmm0;points[x][y][2]=sin(x/5*40/360 * Pi * 2)
	add	esi,SIZEOF_LINE*4
	mov	rax,points
	add	eax,SIZEOF_LINE*SIZEOF_LINE*4
	cmp	esi,eax;we do a int loop unlike Bosco
	jb	@3
        inc	edi
	cmp	edi,SIZEOF_LINE             ;we do a int loop unlike Bosco
	jb	@b
;     
	invoke	glMatrixMode,GL_PROJECTION;     ()

        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke	glLoadIdentity
	movd	xmm6,const1

;     (z=-6)
	movss	xmm2,const_12
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef

	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movss	xmm0,xrot
	invoke	glRotatef
	xorps	xmm3,xmm3
	movss	xmm2,xmm6
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef
	movss	xmm3,xmm6
        xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,zrot
	invoke	glRotatef

        invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	invoke	glBegin,GL_QUADS
	xor	esi,esi;x=0
@@:	mov	rdi,points;y=0
	cvtsi2ss xmm0,esi
        divss	xmm0,const44
        movss	fx,xmm0             ;fx = float(x)/44.0
	addss	xmm0,const0_0227
        movss	fx2,xmm0            ;fx2 = float(x+1)/44.0
;-------------------------------------------------------
@0:     mov	eax,edi
	sub	rax,points
	cvtsi2ss xmm0,eax
	divss	xmm0,const176
	movss	fy,xmm0             ;fy = float(y)/44.0
	addss	xmm0,const0_0227
        movss	fy2,xmm0            ;fy2 = float(y+1)/44.0
	movss	xmm1,fy
	movss	xmm0,fx
	invoke  glTexCoord2f;fx,fy 
	movss	xmm2,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*8];points[x][y][2]
	movss	xmm1,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*4];points[x][y][1]
	movss	xmm0,dword ptr [rdi+rsi*4];points[x][y][0]
	invoke  glVertex3f 
	movss	xmm1,fy2
	movss	xmm0,fx 
	invoke  glTexCoord2f 
	add	edi,SIZEOF_LINE*4
	movss	xmm2,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*8];points[x][y+1][2]
	movss	xmm1,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*4];points[x][y+1][1]
	movss	xmm0,dword ptr [rdi+rsi*4];points[x][y+1][0]
       	invoke  glVertex3f
	movss	xmm1,fy2
	movss	xmm0,fx2
	invoke  glTexCoord2f 
	inc	esi
	movss	xmm2,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*8];points[x+1][y+1][2]
	movss	xmm1,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*4];points[x+1][y+1][1]
	movss	xmm0,dword ptr [rdi+rsi*4];points[x+1][y+1][0]
       	invoke  glVertex3f
	movss	xmm1,fy
	movss	xmm0,fx2
	invoke  glTexCoord2f 
        sub	edi,SIZEOF_LINE*4
	movss	xmm2,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*8];points[x+1][y][2]
	movss	xmm1,dword ptr [rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*4];points[x+1][y][1]
	movss	xmm0,dword ptr [rdi+rsi*4];points[x+1][y][0]
       	invoke  glVertex3f   
	dec	esi
        add	edi,SIZEOF_LINE*4
	mov	rax,points
	add	eax,(SIZEOF_LINE-1)*SIZEOF_LINE*4
	cmp	edi,eax
	jb	@0
;----------------------------------------------
        inc	esi               ;x++ for the loop
	cmp	esi,SIZEOF_LINE-1
	jb	@b
	invoke	glEnd
	cmp	wiggle_count,2   ;trick to slow down animation (!)
	jne	@f
        mov	rdi,points
@1:	mov	eax,[rdi+SIZEOF_LINE*SIZEOF_LINE*8]
	mov	hold,eax
	xor	esi,esi
@2:	mov	ecx,[rdi+rsi*4+4+SIZEOF_LINE*SIZEOF_LINE*4*2]
        mov	[rdi+rsi*4+SIZEOF_LINE*SIZEOF_LINE*4*2],ecx;points[x][y][2] = points[x+1][y][2]
	inc	esi
        cmp	esi,SIZEOF_LINE;-1
	jb	@2
	mov	ecx,hold
	mov	[rdi+SIZEOF_LINE*SIZEOF_LINE*8+(SIZEOF_LINE-1)*4],ecx;points[44][y][2]=hold
	add	edi,SIZEOF_LINE*4
	mov	rax,points
	add	eax,SIZEOF_LINE*SIZEOF_LINE*4
        cmp	edi,eax
	jb	@1
        and	wiggle_count,0
@@:	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#11: Flag Effect (Waving Texture)",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "flag.bmp",0
texture		dd ?
Texture1_Id	dq ?
wiggle_count    db 0
points          dq ?;	d SIZEOF_LINE*SIZEOF_LINE*3 dup(?)
hold            dd ?
;-----------------------------
;float
const0_0227     dd 0.0227
const1		dd 1.0
constPi         dd 3.14159265358979323846264338328
const4_5	dd 4.5
const5		dd 5.0
const_12	dd -12.0
const22_5	dd 22.5
const44		dd 44.0
const176	dd 176.0
const900	dd 900.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
LightAmbient    dd 0.5, 0.5, 0.5;,1.0
LightDiffuse    dd 4 dup (1.0)
LightPosition   dd 0, 0, 2.0, 1.0
align 16
xrot		dd 0,  0,  0,  0
xspeed		dd 0.3,0.2,0.4,0
end